/*
mqnc.c Version 0.1.0. Marquee for NCurses
Copyright (C) 2001  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <ncurses.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

int runflg;

void putstx(pgm)
char *pgm;
   {
   fprintf(stderr,"Usage: %s <filename>\n", pgm);
   exit(1);
   } /* putstx */

void initnc()
   {
   initscr();
   cbreak();
   noecho();
   nonl();
   intrflush(stdscr,FALSE);
   keypad(stdscr,TRUE);
   nodelay(stdscr,TRUE);
   curs_set(0);
   clear();
   refresh();
   } /* initnc */

void escape()
   {
   int ch;
   char str[64];
   ch = getch();
   ch = toupper(ch);
   if (ch == 0x1b)
      {
      runflg = 0;
      endwin();
      exit(0);
      }
   else if (ch == 'Q')
      {
      runflg = 0;
      endwin();
      exit(0);
      }
   } /* escape */

int getbyte(hndl)
int hndl;
   {
   int len;
   unsigned char buf[8];
   unsigned char *p;
   p = buf;
   len = read(hndl,buf,1);
   if (len == 0)
      return(EOF);
   else if (len < 0)
      {
      fprintf(stderr,"Error reading input file\n");
      perror("Read error");
      exit(1);
      } /* if read err */
   else
      return(*p);
   } /* getbyte */

void putmsg(str)
char *str;
   {
   int i,col;
   char *p,*q;
   char msg[128];
   p = str;
   while (runflg)
      {
      escape();
      if (!runflg) return;
      strncpy(msg,p,79);
      msg[79] = '\0';
      move(10,0);
      clrtoeol();
      addstr(msg);
      refresh();
      p++;
      if (*p == '\0') p = str;
      p++;
      if (*p == '\0') p = str;
      p++;
      if (*p == '\0') p = str;
      p++;
      if (*p == '\0') p = str;
      p++;
      if (*p == '\0') p = str;
      p++;
      if (*p == '\0') p = str;
      p++;
      if (*p == '\0') p = str;
      p++;
      if (*p == '\0') p = str;
      escape();
      if (runflg) sleep(1);
      } /* msg loop */
   } /* putmsg */

int main(argc,argv)
int argc;
char **argv;
   {
   int hndl,rslt,ch;
   char fname[128];
   char *str;
   char *p,*q;
   if (argc != 2) putstx(*argv);
   strcpy(fname,*(argv+1));
   hndl = open(fname,O_RDONLY);
   if (hndl < 0)
      {
      fprintf(stderr,"Error opening %s\n", fname);
      perror("Open error");
      exit(1);
      } /* if open err */
   str = (char *) malloc(1024*1024);
   if (str == NULL)
      {
      fprintf(stderr,"Not enough memory.\n");
      exit(1);
      } /* not enough memory */
   runflg = 1;
   str[0] = ' ';
   strncpy(str+1,str,79);
   str[79] = '\0';
   p = str+79;
   q = str + (1024*1024) - 64;
   while (p < q)
      {
      ch = getbyte(hndl);
      if (ch == EOF) break;
      else if (ch < ' ' || ch > 127) ch = ' ';
      *p++ = ch;
      } /* fill str */
   *p = '\0';
   rslt = close(hndl);
   if (rslt < 0)
      {
      fprintf(stderr,"Error closing %s\n", fname);
      perror("Close error");
      exit(1);
      } /* if open err */
   if (strlen(str) == 79) return(0);
   initnc();
   putmsg(str);
   endwin();
   return(0);
   } /* main */
